<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 09/09/2008 *
 * ===============                              Last change: 09/09/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : load_cache-config.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Load more cache files                            *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Mehr Cache-Dateien nachladen                     *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (ereg(basename(__FILE__), $_SERVER['PHP_SELF'])) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Next cached table is the referral system (refdepths)...
if ($cacheInstance->cache_file("refdepths", true) == true) {
	// Load referral system from cache
	global $cacheArray;
	$cacheArray['ref_depths'] = $cacheInstance->cache_load();

	// Valid cache file
	$CNT = 0;
	foreach ($cacheArray['ref_depths'] as $k=>$array) {
		$CNT += count($array);
	}

	// When there is a period (.) in the result this test will fail and so the cache file is
	// damaged/corrupted
	$TEST = "failed";
	if (count($cacheArray['ref_depths']) > 0 ) $TEST = ($CNT / (count($cacheArray['ref_depths'])));
	if ($TEST != bigintval($TEST)) {
		// Cache file is corrupted!
		$cacheInstance->cache_destroy();
		unset($cacheArray['ref_depths']);
	}
} elseif (($_CONFIG['cache_refdepth'] == "Y") && ($CSS != "1") && ($CSS != "-1")) {
	// Create cache file here
	$cacheInstance->cache_init("REFDEPTHS");

	// Load all modules and their data
	$result = SQL_QUERY("SELECT id, level, percents FROM "._MYSQL_PREFIX."_refdepths ORDER BY level", __FILE__, __LINE__);
	while ($DATA = SQL_FETCHARRAY($result)) {
		// Add row to cache file
		$cacheInstance->add_row($DATA);
	}

	// Free memory
	SQL_FREERESULT($result);
}

// Close file
$cacheInstance->cache_close();

// Next cached table is the referral system (admins_acls)...
if (GET_EXT_VERSION("admins") >= "0.3") {
	// Check for cache file
	if ($cacheInstance->cache_file("admins_acls", true) == true) {
		// Load referral system from cache
		global $cacheArray;
		$cacheArray['admin_acls'] = $cacheInstance->cache_load();

		// Valid cache file
		$CNT = 0;
		foreach ($cacheArray['admin_acls'] as $k=>$array) {
			$CNT += count($array);
		}

		// When there is a period (.) in the result this test will fail and so the cache file is
		// damaged/corrupted
		if (count($cacheArray['admin_acls']) > 0) {
			$TEST = "failed";
			if (count($cacheArray['admin_acls']) > 0 ) $TEST = ($CNT / (count($cacheArray['admin_acls'])));
			if ($TEST != bigintval($TEST)) {
				// Cache file is corrupted!
				$cacheInstance->cache_destroy();
				unset($cacheArray['admin_acls']);
			}
		}
	} elseif (($_CONFIG['cache_acls'] == "Y") && ($CSS != "1") && ($CSS != "-1")) {
		// Create cache file here
		$cacheInstance->cache_init("ADMINS_ACLS");

		// Load all modules and their data
		$result = SQL_QUERY("SELECT id, admin_id, action_menu, what_menu, access_mode FROM "._MYSQL_PREFIX."_admins_acls ORDER BY admin_id, action_menu, what_menu", __FILE__, __LINE__);
		while ($DATA = SQL_FETCHARRAY($result)) {
			// Add row to cache file
			$cacheInstance->add_row($DATA);
		}

		// Free memory
		SQL_FREERESULT($result);
	}

	// Close file
	$cacheInstance->cache_close();
}

//
?>
